#include <FastArduino.h>


void f_FastdigitalWrite(unsigned char pin, unsigned char val)
{
	unsigned char bit = digitalPinToBitMask(pin);
	volatile unsigned char *out;
	out = portOutputRegister(digitalPinToPort(pin));
  if (val != LOW) *out |= (unsigned char)bit;
  else *out &= ~(unsigned char)bit;
}




void f_FastshiftOut(const unsigned char dataPin, const unsigned char clockPin, const unsigned char bitOrder, const unsigned char val)
{
	register unsigned char i;

	for (i = 8; i ; i--)  {
		if (bitOrder != LSBFIRST) f_FastdigitalWrite(dataPin, !!((unsigned char)val & (1 << ((unsigned char)i-1))));
		else f_FastdigitalWrite(dataPin, !!(val & (1 << (8 - i)))); //MSBFIRST //LSBFIRST
		f_FastdigitalWrite(clockPin, HIGH);
		f_FastdigitalWrite(clockPin, LOW);


	}
}


void f_FastdigitalPulse(unsigned char pin, unsigned char val)
{
	unsigned char bit = digitalPinToBitMask(pin);
	volatile unsigned char *out;
	out = portOutputRegister(digitalPinToPort(pin));
  if (val) {*out |= bit;*out &= ~bit;}
  else {*out &= ~bit;*out |= bit;}

}
//asm volatile("nop \n\t nop \n\t nop \n\t nop");
