#include <hc595.h>


hc595::hc595(unsigned char latch,unsigned char clock,unsigned char data,unsigned char  num)
{
  latchPin=latch;
  clockPin=clock;
  dataPin=data;
  Buffer=(unsigned char*)malloc(num);  // num is number of 74HC595 connected
  for(unsigned char i=0;i<num;i++) Buffer[i]=0;
  pinMode(latchPin, OUTPUT);
  pinMode(dataPin, OUTPUT);
  pinMode(clockPin, OUTPUT);
  num_595=num;

  b_Latch = digitalPinToBitMask(latchPin);;
  //b_Clock = digitalPinToBitMask(clockPin);;
  //b_Data = digitalPinToBitMask(dataPin);;


  p_Latch=(unsigned char *)portOutputRegister(digitalPinToPort(latchPin));
  //p_Clock=(unsigned char *)portOutputRegister(digitalPinToPort(clockPin));
  //p_Data=(unsigned char *)portOutputRegister(digitalPinToPort(dataPin));

}
/*
hc595::~hc595()
{
 free(Buffer);
 Buffer=0;
}*/

void hc595::PulseE(unsigned char num)
{
  bitWrite(Buffer[num],3,LOW); // set enable pin to low
  Send595();
  delayMicroseconds(1);//delayMicroseconds(1);   // >450ns
  //__asm__("nop\n\t""nop\n\t""nop\n\t""nop\n\t""nop\n\t""nop\n\t""nop\n\t""nop\n\t"); // fanne 8
  bitWrite(Buffer[num],3,HIGH); // set enable pin to  high
  Send595();
  delayMicroseconds(1);//delayMicroseconds(1);    //  >450ns
  //__asm__("nop\n\t""nop\n\t""nop\n\t""nop\n\t""nop\n\t""nop\n\t""nop\n\t""nop\n\t");
  bitWrite(Buffer[num],3,LOW); // set enable pin to low
  Send595();
  delayMicroseconds(38);   //  > 37us
}

void hc595::Send595(void)
{
 *p_Latch &= ~(unsigned char)b_Latch;//DirectdigitalWrite(b_Latch,p_Latch, LOW); //FastdigitalWrite(latchPin, LOW);//*p_Latch &= ~b_Latch; //
 for(register unsigned char i=num_595;i;i--)
 {
    FastshiftOut(dataPin, clockPin, MSBFIRST, Buffer[i-1]);//DirectshiftOut(Buffer[i-1]);//
    /*for (register unsigned char z = 8; z; z--)
    {
      //( (Buffer[i-1] & (1 << (7 - z))) != LOW)?*p_Data |= (unsigned char)b_Data:*p_Data &= ~(unsigned char)b_Data;
      //hc595_DirectdigitalWrite(b_Data,p_Data, !!(val & (1 << (7 - i))));
      //( !!(val & (1 << (7 - i))) != LOW)?*p_Data |= b_Data:*p_Data &= ~b_Data;
      f_FastdigitalWrite(dataPin, !!(Buffer[i-1] & (1 << (z-1))));

      *p_Clock |= (unsigned char)b_Clock; //DirectdigitalWrite(b_Clock,p_Clock, HIGH); //f_FastdigitalWrite(clockPin, HIGH);
      *p_Clock &= ~(unsigned char)b_Clock;//DirectdigitalWrite(b_Clock,p_Clock, LOW);//f_FastdigitalWrite(clockPin, LOW);
    }*/
 }

 *p_Latch |=(unsigned char) b_Latch;//DirectdigitalWrite(b_Latch,p_Latch, HIGH);//FastdigitalWrite(latchPin, HIGH);//*p_Latch |= b_Latch;///

}

void hc595::Send595Pin(unsigned char val,unsigned char display)
{
  Set595Pin(val,display);
  Send595();
}

void hc595::Set595Pin(bool D7,bool D6,bool D5,bool D4,bool D3,bool D2,bool D1,bool D0,unsigned char num)
{
 Buffer[num]=(D7<<7)+(D6<<6)+(D5<<5)+(D4<<4)+(D3<<3)+(D2<<2)+(D1<<1)+D0;
}



void hc595::Set595Pin(unsigned char val,unsigned char num)
{
 Buffer[num]=val;
}

void hc595::Lcd_SetFreePin(unsigned char pin, bool status,unsigned char sr)
{
  bitWrite(Buffer[sr],pin,status);
  Send595();
}


void hc595::DisplayReset(unsigned char options,unsigned char num)
{
  if(!options) options=LCD595_BASIC_DISPLAY_INIT | LCD595_USEFONT_5X10 | LCD595_MORELINES;
  //procedura di reset
  delayMicroseconds(4100); // attesa iniziale....40ms ( ho usato tempi abbondanti

  SetLcdPin(0,0,1,1,num); // invio 0011
  PulseE(num);
  delayMicroseconds(4200); // 4.1ms

  SetLcdPin(0,0,1,1,num); // reinvio 0011
  PulseE(num);
  delayMicroseconds(110); // 100us

  SetLcdPin(0,0,1,1,num); // reinvio 0011
  PulseE(num);

  SetLcdPin(0,0,1,0,num); // ...settiamo i 4 bit...
  PulseE(num);


  SendLcdCommand(options,num);  // Inizializzazione con font e righe : 42    0 0 1 DL N F 0 0 (DL: 0 (4bit), N=1 (due righe)  F:5x8 (0) vs 15x10 (1))
  SendLcdCommand(LCD595_DISPLAY_ON,num);  // accendo il display
  SendLcdCommand(LCD595_DISPLAY_CLEAR,num);  // clear

}

void hc595::DisplayWrite(const char *buff,unsigned char display)
{
  int ln=strlen(buff);
  for(int i=0;i<ln;i++) {DisplayChar(buff[i],display);}

}

void hc595::DisplayChar(unsigned char buff,unsigned char display)
{
  //scrivo una lettera OPPURE invio dati generici per altri scopi
  SetLcdRS(HIGH,display); // porto RS ad HIGH per indicare l'invio di DATI
  SetHLcd(buff,display);
  PulseE(display);
  SetLLcd(buff,display);
  PulseE(display);
  delayMicroseconds(37); // 37us
}

void hc595::SetLcdPin(bool D7,bool D6,bool D5,bool D4,unsigned char num)
{
 bitWrite(Buffer[num],7,D7);
 bitWrite(Buffer[num],6,D6);
 bitWrite(Buffer[num],5,D5);
 bitWrite(Buffer[num],4,D4);
}



void hc595::SetCursor(unsigned char X, unsigned char Y,unsigned char type,unsigned char display)
{
  int row_offsets[] = { 0x00, 0x40, 0x14, 0x54 };     //type 1
  if(type==2) {row_offsets[2]=0x10; row_offsets[3]=0x50;}

  if(Y>3) Y=Y%4;
  unsigned char val;
  val=(0x80 | (X + row_offsets[Y]));
  SendLcdCommand(val,display);
}


void hc595::SetDDRAM_Address(unsigned char address,unsigned char display)
{
  unsigned char val=(0x80 | address);
  SendLcdCommand(val,display);
}

void hc595::CreateChar(unsigned char address,unsigned char map[],unsigned char display)
{
  address &= 0x7; // we have only 8 locations 0-7
  SendLcdCommand(0x40 | (address << 3),display);
  for (int i=0; i<8; i++) DisplayChar(map[i],display);

}

 void hc595::SendLcdCommand(unsigned char val,unsigned char display)
 {
   SetLcdRS(LOW,display);
   SetHLcd(val,display);
   PulseE(display);
   SetLLcd(val,display);
   PulseE(display);
   delayMicroseconds(37); // 37us
   if(val==LCD595_DISPLAY_CLEAR) delayMicroseconds(15300);//delay(2); //1.52ms
}

 void hc595::SetLcdRS(bool Val,unsigned char display)
 {
  bitWrite(Buffer[display],1,Val); // porto RS ad HIGH per indicare l'invio di DATI o LOW per i comandi

 }

 void hc595::SetHLcd(unsigned char val,unsigned char display)
 {
  SetLcdPin(bitRead(val,7),bitRead(val,6),bitRead(val,5),bitRead(val,4),display); // primi 4
 }

 void hc595::SetLLcd(unsigned char val,unsigned char display)
 {
  SetLcdPin(bitRead(val,3),bitRead(val,2),bitRead(val,1),bitRead(val,0),display); // ultimi 4
 }

/*
inline void hc595::DirectdigitalWrite(unsigned char bit, unsigned char * out,unsigned char val)
{
  val?*out |= (unsigned char)bit:*out &= ~(unsigned char)bit;
  //if (val != LOW) *out |= bit;
  //else *out &= ~bit;

}*/
/*
void hc595::DirectshiftOut(const unsigned char val)
{
	for (unsigned char i = 0; i < 8; i++)
  {
    ( (val & (1 << (7 - i))) != LOW)?*p_Data |= (unsigned char)b_Data:*p_Data &= ~(unsigned char)b_Data;
  	//hc595_DirectdigitalWrite(b_Data,p_Data, !!(val & (1 << (7 - i))));
  	//( !!(val & (1 << (7 - i))) != LOW)?*p_Data |= b_Data:*p_Data &= ~b_Data;
		//f_FastdigitalWrite(dataPin, !!(val & (1 << (7 - i))));

		*p_Clock |= (unsigned char)b_Clock; //DirectdigitalWrite(b_Clock,p_Clock, HIGH); //f_FastdigitalWrite(clockPin, HIGH);
		*p_Clock &= ~(unsigned char)b_Clock;//DirectdigitalWrite(b_Clock,p_Clock, LOW);//f_FastdigitalWrite(clockPin, LOW);
	}
}
*/



